Bug 114400 - The draw:fontwork-xyz attributes from OOo1.0 are not supported by ODF but still written
Summary: The draw:fontwork-xyz attributes from OOo1.0 are not supported by ODF but sti...
Status: ASSIGNED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: x86-64 (AMD64) Windows (All)
: medium normal
Assignee: Ilhan Yesil
URL:
Whiteboard: target:6.2.0 target:6.1.2 target:6.0.7
Keywords:
Depends on:
Blocks: ODF-export-invalid
  Show dependency treegraph
 
Reported: 2017-12-11 00:27 UTC by Regina Henschel
Modified: 2019-02-05 16:23 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
Text on path examples (11.86 KB, application/vnd.oasis.opendocument.graphics)
2017-12-11 00:27 UTC, Regina Henschel
Details
Example with drawooo namespace instead (11.83 KB, application/vnd.oasis.opendocument.graphics)
2018-08-21 14:45 UTC, Thorsten Behrens (CIB)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Regina Henschel 2017-12-11 00:27:03 UTC
Created attachment 138353 [details]
Text on path examples

LibreOffice knows a "text on path" feature with several variants. They are written to file in attributes of type draw:fontwork-xyz. These attributes belong to OOo1.0, see dtd in share/dtd/officedocument/1.0/drawing.mod in your installation. But these attributes do not belong to ODF.

I don't know, whether these attributes were simple forgotten or whether it was intended to not include them.

This feature corresponds to the SVG element <textPath>, only that <textPath> has not so many variants.

In the current situation LibreOffice would need to write the attributes in its own namespace. I would prefer to get the attributes into ODF.
Comment 1 Buovjaga 2017-12-18 17:09:54 UTC
Setting to NEW.
Comment 2 Thorsten Behrens (CIB) 2018-08-21 14:45:36 UTC
Created attachment 144349 [details]
Example with drawooo namespace instead
Comment 3 Regina Henschel 2018-08-21 16:25:17 UTC
@Thorsten: Do you suggest to use drawooo-namespace until a final solution in ODF is specified? In that case I suggest to correct the wrong mapping in pXML_Fontwork_Shadow_Enum[] in core/xmloff/source/draw/sdpropls.cxx#699. If new documents are written with drawooo and use the correct mapping, old documents with the (wrong) draw namespace can be corrected on import.
Comment 4 Thorsten Behrens (CIB) 2018-08-22 18:10:34 UTC
(In reply to Regina Henschel from comment #3)
> @Thorsten: Do you suggest to use drawooo-namespace until a final solution in
> ODF is specified?
> 

Yep. Would love to have ~all documents at least extended-conformance valid
Comment 5 Commit Notification 2018-09-08 22:02:48 UTC
Ilhan Yesil committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=278e66488135c8fa2714520d056573c64ea803cf

tdf#114400 Import drawoo:fontwork-xyz attributes

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 6 Commit Notification 2018-09-10 08:55:18 UTC
Ilhan Yesil committed a patch related to this issue.
It has been pushed to "libreoffice-6-1":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=7218614a28237c19747eccd3954142c4e3e4ecc7&h=libreoffice-6-1

tdf#114400 Import drawoo:fontwork-xyz attributes

It will be available in 6.1.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2018-09-10 08:55:27 UTC
Ilhan Yesil committed a patch related to this issue.
It has been pushed to "libreoffice-6-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=9b9e6de5c4f6fe3eb9b02e91f7dd7e482ecac5fe&h=libreoffice-6-0

tdf#114400 Import drawoo:fontwork-xyz attributes

It will be available in 6.0.7.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 8 Xisco Faulí 2018-10-11 10:13:57 UTC
A polite ping to Ilhan Yesil:
Is this bug fixed? if so, could you please close it as RESOLVED FIXED ? Otherwise, Could you please explain what's missing?
Thanks
Comment 9 Thorsten Behrens (CIB) 2018-10-11 12:22:17 UTC
There's still https://gerrit.libreoffice.org/59411 pending, but that has to wait a year or so, such that reading capabilities have permeated enough in the install base.

I honestly don't know what a proper bug status is for such a case :)
Comment 10 Regina Henschel 2019-02-05 16:23:59 UTC
My comment requires no immediate acting, but is a reminder for bringing the feature to ODF.

In https://opengrok.libreoffice.org/xref/core/xmloff/source/draw/sdpropls.cxx?r=6e5cdd9d#715
we have the order
static SvXMLEnumMapEntry<sal_Int32> const pXML_Fontwork_Shadow_Enum[] =
{
      { XML_NORMAL,       0 }, //XFormTextShadow::Normal,
      { XML_SLANT,        1 }, //XFormTextShadow::Slant,
      { XML_NONE,         2 }, //XFormTextShadow::NONE
      { XML_TOKEN_INVALID,0 }
};

But in https://opengrok.libreoffice.org/xref/core/include/svx/xenum.hxx?r=49b1107b#26
we have the order
enum class XFormTextShadow  { NONE, Normal, Slant };

This means, that the naming in file format does not fit to the actual meaning. We do not need to correct this now. But it means, that the feature 'FormTextShadow' cannot be brought to ODF 1:1. We need a different specification for ODF.